Proposal

As soon as #16166 issue is implemented, there is more room for improvement. If you look carefully at the logs, you will see how
much valuable information are hidden inside of them:

The debug line

14:54:23.1988 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel
ect_console
14:54:24.2461 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:28 called testapi::ass
ert_script_run
14:54:27.8731 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:28 called testapi::ass
ert_script_run

etc

Since openQA spots the line number of the source file ($test.pm), we can now which code path was touched during the execution
of the test.

The <<< line:

14:54:12.8437 15764 <<< testapi::assert_screen (mustmatch=["'generic-desktop'], timeout=30)
14:54:15.1724 15764 <<< testapi::type_string(string='root', max_interval=250, wait_screen_changes=
0)

14:54:56.7783 15764 <<< testapi::wait_serial (timeout=30, regexp=qr/ (?2”:JgRME-\d+-)/)

We see what openQA requests from the SUT to do.

The >>> line:

14:54:13.9297 15764 >>> testapi::_check_backend_response: found GNOME-20160523, similarity 1.00 @
0/4

14:54:57.8247 15764 >>> testapi::wait_serial: (?":JgRME-\d+-): ok

We see the response of the SUT, back to openQA.

Having these three identifiers in mind, you can improve the logging mechanism, like this:

Log for unzip tests/console/unzip.pm at 2017-01-20 14:54:14

27: select_console "root-console";

REQUEST: assert_screen (mustmatch=['tty2-selected', 'text-logged-in-root', 'text-login'], timeout=60)
REPLY : check_backend_response: found text-1login-20140219, similarity 1.00 @ 0/0

REQUEST: type_string(string='root', max_interval=250, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)

REQUEST: assert_screen (mustmatch='password-prompt', timeout=30)
REPLY : check_backend_response: found password-prompt-20160405, similarity 1.00 Q@ 0/96
REQUEST: type_string(string='SECRET STRING', max_interval=100, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)

REQUEST: send_key (key="ret')

REPLY : User Input (nothing to respond back)

REQUEST: assert_screen (mustmatch='text-logged-in-root', timeout=30)

REPLY : check_backend_response: found text-logged-in-root-20151204, similarity 1.00 @ 63/128
REQUEST: type_string(string='PS1=\"'# \'', max_interval=250, wait_screen_changes=0)

REPLY : User Input (nothing to respond back)

REQUEST: type_string(string='setterm -blank 0', max_interval=250, wait_screen_changes=0)

REPLY : User Input (nothing to respond back)

REQUEST: type_string(string=' ; echo YpuUt-$?- > /dev/ttySO0', max_interval=250, wait_screen_change
s=0)

REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=30, regexp=qr/ (2" :YpuUt-\d+-)/)
REPLY : wait_serial: (?27:YpuUt-\d+-): ok

28: assert_script_run "mkdir -p /tmp/unzip-test/";

REQUEST: type_string(string='mkdir -p /tmp/unzip-test/; echo Hb2bl-$?- > /dev/ttyS0', max_interval
=250, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)

REQUEST: testapi::send_key(key='ret')
REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=90, regexp='Hb2bl-\\d+-"')
REPLY : wait_serial: Hb2bl-\d+-: ok

31: assert_script_run "wget --quiet " . data_url('console/test_unzip.zip') . " -0 /tmp/unzip-test/
archive.zip";

REQUEST: type_string(string='wget --quiet http://10.0.2.2:20023/Vgm_u5zHrnPh24sA/data/console/test
_unzip.zip -0 /tmp/unzip-test/archive.zip; echo fl5gk-$?- > /dev/ttyS0', max_interval=250, wait_sc
reen_changes=0)

REPLY : User Input (nothing to respond back)

REQUEST: testapi::send_key (key='ret')
REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=90, regexp='fl5gk-\\d+-")
REPLY : wait_serial: fl5gk-\d+-: ok

32: assert_script_run "cd /tmp/unzip-test; unzip archive.zip";

REQUEST: type_string(string='cd /tmp/unzip-test; unzip archive.zip; echo Aul7B-$?- > /dev/ttyS0',
max_interval=250, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)

REQUEST: send_key (key="ret"')
REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=90, regexp='Aul7B-\\d+-"')
REPLY : wait_serial: Aul7B-\d+-: ok
33: my S$entries = script_output("ls -1 /tmp/unzip-test/ | wc -1");

REQUEST: type_string(string='curl -f -v http://10.0.2.2:20023/Vam_u5zHrnPh24sA/current_script > /t
mp/scriptx6cVl.sh; echo iL~6F-$?- > /dev/ttyS0', max_interval=250, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)

REQUEST: send_key (key="ret"')
REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=90, regexp='iL~6F-\\d+-"')
REPLY : wait_serial: iL~6F-\d+-: ok

REQUEST: type_string(string='clear', max_interval=250, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)

REQUEST: type_string(string=' ; echo JgRME-$?- > /dev/ttyS0', max_interval=250, wait_screen_change
s=0)
REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=30, regexp=qr/ (?”:JgRME-\d+-)/)
REPLY : wait_serial: (?7:JgRME-\d+-): ok

REQUEST: type_string(string="' (/bin/bash -eox pipefail /tmp/scriptx6cVl.sh ; echo SCRIPT_FINISHEDx6

cV1l-$?-)| tee /dev/ttyS0', max_interval=250, wait_screen_changes=0)

REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=90, regexp='SCRIPT_FINISHEDx6cV1-\\d+-', record_output=1)

REPLY : wait_serial: SCRIPT_FINISHEDx6cV1-\d+-: ok

37: assert_script_run "wget --quiet " . data_url ('console/checklist.md5') . " -O /tmp/unzip-test/c

hecklist.md5";

REQUEST: type_string(string='wget —--quiet http://10.0.2.2:20023/Vgm_ubzHrnPh24sA/data/console/chec
klist.md5 -0 /tmp/unzip-test/checklist.md5; echo 0S50h-$?- > /dev/ttyS0', max_interval=250, wait_s
creen_changes=0)

REPLY : User Input (nothing to respond back)

REQUEST: send_key(key='"ret'")
REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=90, regexp='0OS50h-\\d+-")
REPLY : wait_serial: 0S50h-\d+-: ok

38: assert_script_run "md5sum -c /tmp/unzip-test/checklist.md5";

REQUEST: type_string(string='md5sum —-c /tmp/unzip-test/checklist.md5; echo ZK27y-$?- > /dev/ttySO'
, max_interval=250, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)

REQUEST: send_key (key="ret"')
REPLY : User Input (nothing to respond back)

REQUEST: wait_serial (timeout=90, regexp='ZK27y-\\d+-"')
REPLY : wait_serial: ZK27y-\d+-: ok

REQUEST: type_string(string='cd', max_interval=250, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)

REQUEST: type_string(string='clear',K max_interval=250, wait_screen_changes=0)
REPLY : User Input (nothing to respond back)
REQUEST :
REPLY
/1

assert_screen (mustmatch='cleared-console',
check_backend_response:

Now, see the original log

14:54:14.2858
14:54:14.2861
ect_console

14:54:14.2861
14:54:14.4961
ect_console

14:54:14.4962

15764
Debug:

15764
Debug:

15764

'tty2-selected’,
'text-logged-in-root',

'text-login'
timeout=60)

]I
14:
14:
14:
14:
14:
14:
14:
14:
14:
14:
14:
14

54:
54:
54:
54:
54:
54:
54:
54:
54:
54:

14.
14.

5697
6466
14.6805
14.7317
14.7790
14.8261
14.8739
14.9202
14.9749
15.0409
54:15.0960
:54:15.1718
00 @ 0/0
14:54:15.1723
ect_console
14:54:15.1724

15789
15789
15789
15789
15789
15789
15789
15789
15789
15789
15789
15764

Debug:

15764

', max_interval=250,

14:54:15.5078
ect_console

14:54:15.5079
14:54:15.5806
14:54:15.6510
14:54:15.7111
14:54:15.7652
14:54:15.8253
14:54:15.8886
14:54:15.8888
14:54:16.5187
14:54:16.5267
14:54:16.5542
14:54:16.5632
14:54:16.5709
14:54:16.5781
14:54:16.6466
ty
14:54:16.6467
ect_console

14:54:16.6468
_changes=0)

14:54:18.1507
ect_console

14:54:18.1508
14:54:18.3516
ect_console

14:54:18.3517
14:54:18.4100
14:54:18.4468
14:54:18.4803
14:54:18.5241
1.00 @ 0/96

Debug:

15764
15789
15789
15789
15789
15789
15789
15789
15789
15789
15789
15789
15789
15789
15764

Debug:

15764

Debug:

15764
Debug:

15764
15789
15789
15789
15789

timeout=30)

found cleared-console-autoyast-font-20141126, similarity 1.00 @ O

||| starting unzip tests/console/unzip.pm at 2017-01-20 14:54:14

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel
<<< testapi::select_console(testapi_console='root-console')
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

<<< testapi::assert_screen (mustmatch=][

MATCH (tty2-selected-20151201:1.00)
MATCH (tty2-selected-20160508:0.64)
MATCH (proxymode_text-logged-in-root-ssh-20161107:0.00)
MATCH (proxymode_text-logged-in-root-ssh-20161206:0.00)
MATCH (text-logged-in-root-20151204:0.00)

MATCH (text-logged-in-root-kgraft-20160727:0.00)

MATCH (text-logged-in-root-kgraft-20160728:0.00)

MATCH (text-logged-in-root-kgraft-1tp-20160727:0.00)
MATCH (text-logged-in-root-other-font-20151205:0.00)
MATCH (text-10gin-20140219:1.00)

MATCH (text-1ogin-20160416:1.00)

>>> testapi::_check_backend_response:

found text-login-20140219, similarity 1.

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

<<< testapi::type_string(string='root
wait_screen_changes=0)
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

<<< testapi::assert_screen (mustmatch="'password-prompt', timeout=30)

MATCH (password-prompt—-20141126:0.00)

MATCH (password—prompt—-20150730:0.00)

MATCH (password-prompt—-20160405:0.00)

MATCH (password-prompt—-20160414:0.00)

MATCH (password-prompt-bsc965787-20160216:0.00)

MATCH (password-prompt-xterm-20150818:0.00)

no match 30

MATCH (password-prompt-20141126:

MATCH (password-prompt—-20150730:

MATCH (password-prompt—-20160405:1.00

MATCH (password-prompt—-20160414:0.00)

MATCH (password-prompt-bsc965787-20160216:0.95)

MATCH (password-prompt—-xterm-20150818:0.00)

>>> testapi::_check_backend_response: found password-prompt-20160405,

0.60)
0.00)
)

similari
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

<<< testapi::type_string(string='SECRET STRING', max_interval=100, wait_screen

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

<<< testapi::send_key(key='ret'")
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

<<< testapi::assert_screen (mustmatch="text-logged-in-root', timeout=30)

MATCH (proxymode_text-logged-in-root-ssh-20161107:0.00)

MATCH (proxymode_text—-logged-in-root-ssh-20161206:0.00)

MATCH (text-logged-in-root-20151204:0.00)

MATCH (text-logged-in-root-kgraft-20160727:0.00)
14:
14:
14:
14:

54:
54:
54:18.
54:18.
14:54:19.
14:54:19.
14:54:19.
14:54:19.
14:54:19.
14:54:19.
14:54:19.3960
14:54:19.4417
larity 1.00 @
14:54:19.4417
ect_console
14:54:19.4418 15764
', max_interval=250,
14:54:20.0453 Debug:
ect_console
14:54:20.0454 15764
een_changes=0)
14:54:21.1175 Debug:
ect_console
14:54:21.1176 15764
', max_interval=250,
14:54:23.1988 Debug:
ect_console
14:54:23.1990 15764
14:54:24.2461 15764
14:54:24.2461 Debug:
ert_script_run
14:54:24.2462 15764
/ttyS0', wait=0)
14:54:24.2462 Debug:
ert_script_run
14:54:24.2463 15764
dev/ttyso',
14:54:27.8731 Debug:
ert_script_run
14:54:27.8732 15764
14:54:28.0743 Debug:
ert_script_run
14:54:28.0744 15764
14:54:29.1293 15764
14:54:29.1294 Debug:
ert_script_run
14:54:29.1295 15764

18.
18.

5785
6137
6491
6493
3628
3690
3739
3799
3856
3914

15789
15789
15789
15789
15789
15789
15789
15789
15789
15789
15789
15764

Debug:

4sA/data/console/test_unzip.zip -0 /tmp/unzip-test/archive.zip;

=0)
14:54:29.1295 Debug:
ert_script_run

14:54:29.1295 15764

Ph24sA/data/console/test_unzip.zip -0 /tmp/unzip-test/archive.zip;

ax_interval=250,
14:54:38.4525 Debug:
ert_script_run

14:54:38.4526 15764
14:54:38.6535 Debug:
ert_script_run

14:54:38.6536 15764
14:54:39.7193 15764
14:54:39.7194 Debug:
ert_script_run

14:54:39.7195 15764
B-$?- > /dev/ttysS0',
14:54:39.7195 Debug:
ert_script_run
max_interval=250,

MATCH (text-logged-in-root-kgraft-20160728:0.00)

MATCH (text-logged-in-root-kgraft-1tp-20160727:0.00)

MATCH (text-logged-in-root-other-font-20151205:0.00)

no match 30

MATCH (proxymode_text-logged-in-root-ssh-20161107:0.00)

MATCH (proxymode_text—-logged-in-root-ssh-20161206:0.00)

MATCH (text-logged-in-root-20151204:1.00)

MATCH (text-logged-in-root-kgraft-20160727:0.00)

MATCH (text-logged-in-root-kgraft-20160728:0.00)

MATCH (text-logged-in-root-kgraft-1tp-20160727:0.00)

MATCH (text-logged-in-root-other-font-20151205:0.82)

>>> testapi::_check_backend_response: found text-logged-in-root-20151204, simi
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

<<< testapi::type_string(string="'PS1=\"4# \'

wait_screen_changes=0)
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel
walt_scr

<<< testapi::type_string(string='setterm -blank 0', max_interval=250,

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

<<< testapi::type_string(string=" echo YpuUt-$?- > /dev/ttyS0
wait_screen_changes=0)

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:27 called testapi::sel

’

<<< testapi::wait_serial (timeout=30, regexp=qr/ (?":YpuUt-\d+-)/)
>>> testapi::wait_serial: (?27:YpuUt-\d+-): ok
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:28 called testapi::ass

<<< testapi::script_run(name='mkdir -p /tmp/unzip-test/; echo Hb2bl-$?- > /dev

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:28 called testapi::ass
<<< testapi::type_string(string='mkdir -p /tmp/unzip-test/; echo Hb2bl-$?- > /

wait_screen_changes=0)
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:28 called testapi::ass

<<< testapi::send_key (key="ret')
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:28 called testapi::ass
<<< testapi::wait_serial (timeout=90, regexp='Hb2bl-\\d+-")
>>> testapi::wait_serial: Hb2bl-\d+-: ok
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:31 called testapi::ass
:20023/Vgm_u5zHrnPh?2
> /dev/ttyS0', wait

<<< testapi::script_run (name='wget —--quiet http://10.0.2.2
echo fl5gk-$?2-

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:31 called testapi::ass

<<< testapi::type_string(string='wget —--quiet http://10.0.2.2:20023/Vgm_u5zHrn
echo fl5gk-$?- > /dev/ttySO0', m

wait_screen_changes=0)

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:31 called testapi::ass

<<< testapi::send_key (key="ret')
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:31 called testapi::ass

<<< testapi::wait_serial (timeout=90, regexp='fl5gk-\\d+-")

>>> testapi::wait_serial: fl5gk-\d+-: ok
/var/lib/openga/share/tests/sle/tests/console/unzip.pm:32 called testapi::ass

<<< testapi::script_run(name='cd /tmp/unzip-test; unzip archive.zip; echo Aul7

wait=0)

/var/lib/openga/share/tests/sle/tests/console/unzip.pm:32 called testapi::ass
14:54:39.7196 15764 <<< testapi::type_string(string='cd /tmp/unzip-test; unzip archive.zip; echo A
ul7B-$?- > /dev/ttyS0', max_interval=250, wait_screen_changes=0)

14:54:44.1405 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:32 called testapi::ass
ert_script_run

14:54:44.1406 15764 <<< testapi::send_key(key='ret'")

14:54:44.3414 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:32 called testapi::ass
ert_script_run

14:54:44.3414 15764 <<< testapi::wait_serial (timeout=90, regexp='Aul7B-\\d+-"')

14:54:45.3965 15764 >>> testapi::wait_serial: Aul7B-\d+-: ok

14:54:45.3967 Debug: /var/lib/openqga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:45.3968 15764 <<< testapi::script_run (name='curl -f -v http://10.0.2.2:20023/Vgm_u5zHrnPh24s
A/current_script > /tmp/scriptx6cV1l.sh; echo iL~6F-$?- > /dev/ttyS0', wait=0)

14:54:45.3968 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:45.3969 15764 <<< testapi::type_string(string='curl -f -v http://10.0.2.2:20023/Vgm_u5zHrnPh
24sA/current_script > /tmp/scriptx6cV1l.sh; echo iL~6F-$?- > /dev/ttyS0', max_interval=250, wait_sc
reen_changes=0)

14:54:53.1084 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:53.1085 15764 <<< testapi::send_key(key='ret")

14:54:53.3093 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:53.3094 15764 <<< testapi::wait_serial (timeout=90, regexp='iL~6F-\\d+-")

14:54:54.3653 15764 >>> testapi::wait_serial: iL~6F-\d+-: ok

14:54:54.3653 Debug: /var/lib/openqga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:54.3654 15764 <<< testapi::script_run(name='clear', wait=30)

14:54:54.3655 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:54.3655 15764 <<< testapi::type_string(string='clear', max_interval=250, wait_screen_changes
=0)

14:54:54.7010 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:54.7011 15764 <<< testapi::type_string(string=' ; echo JgRME-$?- > /dev/ttyS0

', max_interval=250, wait_screen_changes=0)

14:54:56.7782 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:56.7783 15764 <<< testapi::wait_serial (timeout=30, regexp=qr/ (?”":JgRME-\d+-)/)

14:54:57.8247 15764 >>> testapi::wait_serial: (?”:JgRME-\d+-): ok

14:54:57.8248 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:54:57.8249 15764 <<< testapi::type_string(string='(/bin/bash -eox pipefail /tmp/scriptx6cVl.sh

; echo SCRIPT_FINISHEDx6cV1-$?-)| tee /dev/ttySO

', max_interval=250, wait_screen_changes=0)

14:55:04.1326 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:33 called testapi::scr
ipt_output

14:55:04.1327 15764 <<< testapi::wait_serial (timeout=90, regexp='SCRIPT_FINISHEDx6cV1-\\d+-', reco
rd_output=1)

14:55:05.1826 15764 >>> testapi::wait_serial: SCRIPT_FINISHEDx6cV1-\d+-: ok

14:55:05.1827 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:37 called testapi::ass
ert_script_run

14:55:05.1828 15764 <<< testapi::script_run (name='wget —--quiet http://10.0.2.2:20023/Vgm_u5zHrnPh2
4sA/data/console/checklist.md5 -0 /tmp/unzip-test/checklist.md5; echo 0S50h-$?- > /dev/ttyS0', wai
t=0)

14:55:05.1828 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:37 called testapi::ass
ert_script_run

14:55:05.1829 15764 <<< testapi::type_string(string='wget —--quiet http://10.0.2.2:20023/Vgm_u5zHrn
Ph24sA/data/console/checklist.md5 -O /tmp/unzip-test/checklist.md5; echo 0S50h-$?- > /dev/ttySO',

max_interval=250, wait_screen_changes=0)

14:55:14.6033 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:37 called testapi::ass
ert_script_run

14:55:14.6034 15764 <<< testapi::send_key(key='ret')

14:55:14.8042 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:37 called testapi::ass
ert_script_run

14:55:14.8043 15764 <<< testapi::wait_serial (timeout=90, regexp='0OS50h-\\d+-")

14:55:15.8781 15764 >>> testapi::wait_serial: 0S50h-\d+-: ok
14:55:15.8782 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:38 called testapi::ass

ert_script_run

14:55:15.8782 15764 <<< testapi::script_run(name='md5sum -c /tmp/unzip-test/checklist.md5; echo ZK

27y-$?- > /dev/ttyS0', wait=0)

14:55:15.8782 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:38 called testapi::ass

ert_script_run

14:55:15.8783 15764 <<< testapi::type_string(string='md5sum -c /tmp/unzip-test/checklist.md5; echo
ZK27y-$?2- > /dev/ttyS0', max_interval=250, wait_screen_changes=0)

14:55:20.4399 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:38 called testapi::ass

ert_script_run

14:55:20.4400 15764 <<< testapi::send_key (key='ret')

14:55:20.6414 Debug: /var/lib/openga/share/tests/sle/tests/console/unzip.pm:38 called testapi::ass

ert_script_run

14:55:20.6415 15764 <<< testapi::wait_serial (timeout=90, regexp='ZK27y-\\d+-")

14:55:21.6875 15764 >>> testapi::wait_serial: ZK27y-\d+-: ok

14:55:21.6876 15764 <<< testapi::type_string(string='cd

', max_interval=250, wait_screen_changes=0)

14:55:21.8893 15764 <<< testapi::type_string(string='clear

', max_interval=250, wait_screen_changes=0)

14:55:22.2932 15764 <<< testapi::assert_screen (mustmatch='cleared-console', timeout=30)
14:55:22.3301 15789 MATCH (cleared-console-autoyast-font-20141126:0.21)

14:55:22.3612 15789 MATCH (consoletest_setup-20141125:0.21)

14:55:22.3613 15789 no match 30

14:55:23.3247 15789 MATCH (cleared-console—autoyast—-font-20141126:1.00)

14:55:23.3531 15789 MATCH (consoletest_setup—-20141125:1.00)

14:55:23.4008 15764 >>> testapi::_check_backend_response: found cleared-console-autoyast-font-2014
1126, similarity 1.00 @ 0/1

14:55:23.4011 15764 ||| finished unzip console at 2017-01-20 14:55:23 (69 s)

So, in the end, lot's of noise is removed, and valuable information are way more easily spotted. As a side-effect, more and more
people will start looking at the logs and make themselves familiar with the internals of openQA.

More from #16184:

As soon as #16166 and #16180 are implemented, there is room for improving the the Ul of openQA, especially for console-based
tests. The current situation is that openQA takes a screenshot if:

e the API call requests a needle to match
¢ the tester wants to save a screenshot
e randomly (every 30 seconds? | am not really sure about the time-frame here)

| would like to propose to disable the feature of openQA to take randomly screenshots. Simply put, if there is not need to take a
screenshot, then do NOT take one. There are console tests that require only 2 or 3 screenshots in order to match these equivalent
needles, however in the end, you see 10 or even more. This is confusing and pointless because these frames were taken out of the
blue.

What | would like to propose here is to take a screenshot per command. By command, is mean the line of the source code of the test
that was touch at that point of time. For example:

Look for the code that was touch in the test (in that case | will show the unzip.pm)

27: select_console "root-console";

28: assert_script_run "mkdir -p /tmp/unzip-test/";

31: assert_script_run "wget —-—quiet " . data_url ('console/test_unzip.zip') . " -0 /tmp/unzip-test/
archive.zip";

32: assert_script_run "cd /tmp/unzip-test; unzip archive.zip";

33: my $entries = script_output("ls -1 /tmp/unzip-test/ | wc —-1");

37: assert_script_run "wget --quiet " . data_url ('console/checklist.md5') . " -O /tmp/unzip-test/c
hecklist.md5";

38: assert_script_run "md5sum -c /tmp/unzip-test/checklist.md5";

So, in this particular example, openQA should show only 7 screenshots (meaning 1 screenshot per command). In that scenario,
when the user clicks on one of them, then given that #16180 is implemented, openQA can show these logs right away. In that way,
the whole review of a test is freaking quick and more enjoyable, since this is exactly the behavior that the user expects to see. In
other words, people will enjoy debugging in openQA!

Furthermore, by implementing this feature, there will be no need for this extra screenshot (usually either green or red, >_) which
checks for wait_serial expected. Actually, you can adapt this coloring-scheme functionality to these new screenshots (per command)
| proposed, so if it passes: green, otherwise make it red as a whole unit.

Now, related to the other screenshots that openQA captures (I am referring to those required screenshots for needle-matching), |
would like to hide them unless they missmatch. For example, matching a needle is part of an api-call. So, if we have screenshot per
command (which includes none, or one or more API calls) there is not need to have extra ones, unless if a needle-matching has
been failed.

So, less confusion, less disk space, more clarity, more fun :-)

Alternative approaches

An "interactive" log viewer with opening logs at the time when screenshot is made in the test details view.

Related issues:

Related to openQA Project - action #68146: Implement colored and interactive ... Resolved 2020-06-16
Blocked by openQA Project - action #16166: Log per test Rejected 2017-01-24
Precedes openQA Project - action #16184: Better Ul log viewer Rejected 2017-01-24
History

#1 - 2017-01-23 13:26 - szarate
- Precedes action #16166: Log per test added

#2 - 2017-01-23 13:27 - szarate
- Precedes deleted (action #16166: Log per test)

#3 - 2017-01-23 13:27 - szarate
- Blocked by action #16166: Log per test added

#4 - 2017-01-23 13:28 - szarate
- Precedes action #16184: Better Ul log viewer added

#5 - 2017-01-24 11:46 - szarate

- Target version set to future

#6 - 2017-02-16 09:35 - okurz

- Category set to Feature requests

#7 - 2018-06-15 19:07 - okurz

- Target version changed from future to future

#8 - 2020-02-12 15:16 - okurz

- Description updated

merged in content from #16184

#9 - 2020-04-23 18:36 - okurz

- Priority changed from Normal to Low

#10 - 2020-10-20 21:47 - okurz

- Related to action #68146: Implement colored and interactive logs added

#11 - 2020-10-20 21:52 - okurz

- Description updated

included proposal from #68146

#12 - 2021-05-17 11:10 - okurz
- Parent task set to #39719
#13 - 2021-11-23 21:40 - okurz
- Parent task deleted (#39719)
